/*
 * Copyright Bigeon Emmanuel (2014)
 *
 * emmanuel@bigeon.fr
 *
 * This software is a computer program whose purpose is to
 * provide a generic framework for console applications.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */
/**
 * gclc:fr.bigeon.gclc.proc.ProcessListTest.java
 * Created on: Aug 19, 2017
 */
package fr.bigeon.gclc.proc;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import java.io.IOException;

import org.junit.Test;

import fr.bigeon.gclc.exception.CommandRunException;
import fr.bigeon.gclc.manager.PipedConsoleManager;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon */
public class ProcessListTest {

    /** Test method for
     * {@link fr.bigeon.gclc.proc.ProcessList#execute(java.lang.String[])}.
     *
     * @throws CommandRunException if an error occured in the execution
     * @throws IOException if the manager could not be created */
    @Test
    public final void testExecute() throws CommandRunException, IOException {
        final TaskPool pool = new TaskPool();
        try (PipedConsoleManager pcm = new PipedConsoleManager()) {
            final ProcessList pl = new ProcessList("list", pool, pcm);
            pl.execute();
            pool.add(new Task() {

                @Override
                public void addInterruptionListener(final InterruptionListener listener) {
                    //
                }

                @Override
                public String getName() {
                    return "name";
                }

                @Override
                public boolean isRunning() {
                    return false;
                }

                @Override
                public void rmInterruptionListener(final InterruptionListener listener) {
                    //
                }

                @Override
                public void run() {
                    // TODO Auto-generated method stub
                    //
                    throw new RuntimeException("Not implemented yet");
                }

                @Override
                public void setRunning(final boolean running) {
                    //
                }
            });
            pl.execute();
            assertTrue("List should give the process",
                    pcm.readNextLine().endsWith("name"));
        }
    }

    @Test
    public void testTip() throws IOException {
        try (PipedConsoleManager pcm = new PipedConsoleManager()) {
        assertNotNull("Tip should not be null", new ProcessList("list",
                    new TaskPool(), pcm).tip());
        }
    }
}
